structure Parser =
struct
  structure Arg =
  struct
    type string = string
    
    open LambdaPlusPlus

    datatype terminal = datatype Lexer.token

    fun id_typ x = x
    fun id_exp x = x
    val lambda = Lambda o (fn (a, b, c) => ((a, b), c))
    val case_ = Case o (fn (a, b, c, d, e) => (a, (b, c), (d, e)))

    fun error s =
      case Stream.front s of
        Stream.Nil => (print "Syntax error at end of file.\n"; Fail "parse")
    | Stream.Cons ((_, pos), _) =>
        (print "Syntax error at "; print (Int.toString pos); print ".\n"; Fail "parse")
  end

  type pos = int

  structure StreamWithPos =
     CoercedStreamable (structure Streamable = StreamStreamable
                        type 'a item = 'a * pos
                        fun coerce (x, _) = x)

  structure ParseMain = LambdaPlusPlusParseFun (
    structure Streamable = StreamWithPos
    structure Arg = Arg
  )

  fun parse s = #1 (ParseMain.parse (Lexer.lex s))
end
